package me.StevenLawson.TotalFreedomMod.commands;

import me.StevenLawson.TotalFreedomMod.admin.AdminList;
import me.StevenLawson.TotalFreedomMod.player.PlayerData;
import me.StevenLawson.TotalFreedomMod.util.Utilities;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(level = AdminLevel.SUPER, source = SourceType.BOTH)
public class Command_blockcmd extends FreedomCommand {

	@Override
	public boolean run(CommandSender sender, org.bukkit.entity.Player sender_p, Command cmd,
		String commandLabel, String[] args, boolean senderIsConsole) {
		if (args.length != 1) {
			return false;
		}

		if (args[0].equalsIgnoreCase("purge")) {
			Utilities.adminAction(sender.getName(), "Unblocking commands for all players", true);
			int counter = 0;
			for (Player player : server.getOnlinePlayers()) {
				PlayerData playerdata = PlayerData.getPlayerData(player);
				if (playerdata.allCommandsBlocked()) {
					counter += 1;
					playerdata.setCommandsBlocked(false);
				}
			}
			playerMsg(sender, "Unblocked commands for " + counter + " players.");
			return true;
		}

		final Player player = getPlayer(args[0]);

		if (player == null) {
			playerMsg(sender, FreedomCommand.PLAYER_NOT_FOUND);
			return true;
		}

		if (AdminList.isSuperAdmin(player)) {
			playerMsg(sender,
				player.getName() + " is a Superadmin, and cannot have their commands blocked.");
			return true;
		}

		PlayerData playerdata = PlayerData.getPlayerData(player);

		playerdata.setCommandsBlocked(!playerdata.allCommandsBlocked());

		Utilities.adminAction(sender.getName(),
			(playerdata.allCommandsBlocked() ? "B" : "Unb") + "locking all commands for "
				+ player.getName(), true);
		playerMsg(sender, (playerdata.allCommandsBlocked() ? "B" : "Unb") + "locked all commands.");

		return true;
	}
}
