package me.StevenLawson.TotalFreedomMod.commands;

import me.StevenLawson.TotalFreedomMod.manager.VanishManager;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(level = AdminLevel.SUPER, source = SourceType.ONLY_IN_GAME)
public class Command_vanish extends FreedomCommand {

	@Override
	public boolean run(CommandSender sender, Player sender_p, Command cmd,
		String commandLabel, String[] args, boolean senderIsConsole) {
		boolean shouldIVanish = true;
		boolean silent = false;

		if (args.length > 0) {
			if (args[0].equalsIgnoreCase("off")) {
				shouldIVanish = false;
			} else {
				shouldIVanish = !VanishManager.isVanished(sender_p);
			}

			if (args.length > 1) {
				if (args[1].toLowerCase().startsWith("-s")) {
					silent = true;
				}
			}
		} else {
			if (VanishManager.isVanished(sender_p)) {
				shouldIVanish = false;
			}

			if (commandLabel.equalsIgnoreCase("uv") || commandLabel.equalsIgnoreCase("unvanish")) {
				shouldIVanish = false;
			}
		}

		if (shouldIVanish) {
			VanishManager.vanishPlayer(sender_p);

			if (!silent) {
				VanishManager.fakeLeave(sender_p);
			}
		} else {
			VanishManager.unvanishPlayer(sender_p);

			if (!silent) {
				VanishManager.fakeJoin(sender_p);
			}
		}

		playerMsg(sender,
			String.format("Your vanish has been %s.", (shouldIVanish) ? "enabled" : "disabled"));

		return true;
	}
}
